----------------------------------------------------------------------------------------------------
-- DotFocus
-- Author: Snowcloud (Micâh - Antonidas)
-- Codebase by: Meranannon (Insane - Vol'jin)
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
-- INDEX_VARIABLE              INDEX   TOKEN
-- ======================================================
-- SPELL_POWER_MANA            0       "MANA"
-- SPELL_POWER_RAGE            1       "RAGE"
-- SPELL_POWER_FOCUS           2       "FOCUS"
-- SPELL_POWER_ENERGY          3       "ENERGY"
-- SPELL_POWER_COMBO_POINTS    4       "COMBO_POINTS"
-- SPELL_POWER_RUNES           5       "RUNES"
-- SPELL_POWER_RUNIC_POWER     6       "RUNIC_POWER"
-- SPELL_POWER_SOUL_SHARDS     7       "SOUL_SHARDS"
-- SPELL_POWER_LUNAR_POWER     8       "LUNAR_POWER"
-- SPELL_POWER_HOLY_POWER      9       "HOLY_POWER"
-- SPELL_POWER_ALTERNATE_POWER 10      ???
-- SPELL_POWER_MAELSTROM       11      "MAELSTROM"
-- SPELL_POWER_CHI             12      "CHI"
-- SPELL_POWER_INSANITY        13      "INSANITY"
-- SPELL_POWER_OBSOLETE        14      ???
-- SPELL_POWER_OBSOLETE2       15      ???
-- SPELL_POWER_ARCANE_CHARGES  16      "ARCANE_CHARGES"
-- SPELL_POWER_FURY            17      "FURY"
-- SPELL_POWER_PAIN            18      "PAIN"
----------------------------------------------------------------------------------------------------

local DF = DOF_namespace
local _

local frame=nil
local frameTexture=nil

local frequency =1/60
local tempo=(frequency/15)*2

local combos={
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0},
	{frame=nil,overlay=nil,texture=nil,scale=1,sTexture=nil,state=0}
}

local frametext=nil
local frametextTexture=nil
local frametextzoom=nil

local combotext = nil
local comboPts = 0

-- initialisation frames
function DF:init_combo_frame()
	
	local anchorx
	local anchory
	
	if not frame then
		
		-- cadre principal
		frame = CreateFrame("FRAME","DF_COMBO_FRAME",DF.anchor[1].frame)
		frame:SetScript("OnMouseDown",function(self,button)
			if button=="LeftButton" then
  			frame:StartMoving()
  		elseif button=="RightButton" then
  			DF:options_show("DFcombo",frame)
  		end
		end)
		frame:SetScript("OnMouseUp",function(self,button)
			if button=="LeftButton" then
	  		frame:StopMovingOrSizing()
	  		local anchorx=DF.anchor[1].frame:GetLeft()
	  		local anchory=DF.anchor[1].frame:GetTop()
	  		DOF_config.combo.positionx=self:GetLeft()-anchorx
	  		DOF_config.combo.positiony=self:GetTop()-anchory
	  		frame:ClearAllPoints()
	  		frame:SetPoint("TOPLEFT", DF.anchor[1].frame, "TOPLEFT", DOF_config.combo.positionx, DOF_config.combo.positiony)
				DF:updateWidgetValue("DFcomboleft")
				DF:updateWidgetValue("DFcombotop")
		  end
		end)	
		frame:SetScript("OnEnter",function(self,button)
			if DF.configmode then
				DF.DotFGameTooltip:SetOwner(UIParent, "ANCHOR_TOPLEFT ",16,-16)
				DF.DotFGameTooltip:ClearLines()
				DF.DotFGameTooltip:AddLine("DOTFOCUS COMBO",1,1,0,nil)
				DF.DotFGameTooltip:AddLine(DF.locale["leftMB"],1,1,1,nil)
				DF.DotFGameTooltip:AddLine(DF.locale["rightMB"],1,1,1,nil)
				DF.DotFGameTooltip:Show()		
			end		
		end)		
		frame:SetScript("OnLeave",function(self,button)
			if DF.configmode then DF.DotFGameTooltip:Hide() end
		end)		

		frametext = CreateFrame("FRAME","DF_COMBO_FRAME_TEXT",DF.anchor[1].frame)
		frametext:SetScript("OnMouseDown",function(self,button)
			if button=="LeftButton" then
  			frametext:StartMoving()
  		elseif button=="RightButton" then
  			DF:options_show("DFcombo",frame)
  		end
		end)
		frametext:SetScript("OnMouseUp",function(self,button)
			if button=="LeftButton" then
	  		frametext:StopMovingOrSizing()
	  		local anchorx=DF.anchor[1].frame:GetLeft()
	  		local anchory=DF.anchor[1].frame:GetTop()
	  		DOF_config.combo.textOffsetX=self:GetLeft()-anchorx
	  		DOF_config.combo.textOffsetY=self:GetTop()-anchory
	  		frametext:ClearAllPoints()
	  		frametext:SetPoint("TOPLEFT", DF.anchor[1].frame, "TOPLEFT", DOF_config.combo.textOffsetX, DOF_config.combo.textOffsetY)
		  end
		end)	
		frametext:SetScript("OnEnter",function(self,button)
			if DF.configmode then
				DF.DotFGameTooltip:SetOwner(UIParent, "ANCHOR_TOPLEFT ",16,-16)
				DF.DotFGameTooltip:ClearLines()
				DF.DotFGameTooltip:AddLine("DOTFOCUS COMBOTEXT",1,1,0,nil)
				DF.DotFGameTooltip:AddLine(DF.locale["leftMB"],1,1,1,nil)
				DF.DotFGameTooltip:AddLine(DF.locale["rightMB"],1,1,1,nil)
				DF.DotFGameTooltip:Show()		
			end		
		end)		
		frametext:SetScript("OnLeave",function(self,button)
			if DF.configmode then DF.DotFGameTooltip:Hide() end
		end)		
		
		-- points de combo
		for i = 1,10 do
			combos[i].frame = CreateFrame("FRAME","DF_COMBO_FRAME_"..tostring(i),frame)
			combos[i].overlay = CreateFrame("FRAME","DF_COMBO_"..tostring(i),combos[i].frame)
			combos[i].texture = combos[i].overlay:CreateTexture("DF_COMBO_TEXTURE"..tostring(i),"BACKGROUND")
			combos[i].frame:EnableMouse(false)

			DF:luaCode_addRefs("Combo_Overlay_"..tostring(i),combos[i].overlay)
			DF:luaCode_addRefs("Combo_Texture_"..tostring(i),combos[i].texture)

		end
		frame:EnableMouse(false)
		frametext:EnableMouse(false)
		frameTexture = frame:CreateTexture("DF_COMBO_FRAME_texture","BACKGROUND")
		
		frametextzoom = CreateFrame("FRAME","DF_COMBO_FRAMETEXTZOOM",frametext)
		combotext = frametextzoom:CreateFontString("DF_COMBOTEXT","ARTWORK")
		frametextTexture = frametext:CreateTexture("DF_COMBO_FRAME_TEXTURE","BACKGROUND")
		
	end

	if not DOF_config.combo.newLevel then
		DOF_config.combo.newLevel=DOF_config.combo.level*10
	end
	local level = DOF_config.combo.newLevel

	-- paramétres cadre principal
	frame:SetMovable(true)
	frame:EnableMouse(false)
	frame:SetWidth(DOF_config.combo.width+8)
	frame:SetHeight(DOF_config.combo.height+8)
	frame:ClearAllPoints()
	frame:SetPoint("TOPLEFT", DF.anchor[1].frame, "TOPLEFT", DOF_config.combo.positionx, DOF_config.combo.positiony)
	--frame:SetFrameLevel(level)

	frametextzoom:SetMovable(false)
	frametextzoom:EnableMouse(false)
	frametextzoom:SetWidth(32)
	frametextzoom:SetHeight(32)
	frametextzoom:ClearAllPoints()
	frametextzoom:SetPoint("CENTER", frametext, "CENTER", 0, 0)
	--frametextzoom:SetFrameLevel(level+7)

	frametext:SetMovable(true)
	frametext:EnableMouse(false)
	frametext:SetWidth(32)
	frametext:SetHeight(32)
	frametext:ClearAllPoints()
	frametext:SetPoint("TOPLEFT", DF.anchor[1].frame, "TOPLEFT", DOF_config.combo.textOffsetX, DOF_config.combo.textOffsetY)
	--frametext:SetFrameLevel(level+7)

	-- paramétres texture
	frameTexture:SetTexCoord(0, 1, 0, 1)
	frameTexture:ClearAllPoints()
	frameTexture:SetAllPoints(frame)

	frameTexture:SetColorTexture(1,1,1,0)

	frametextTexture:SetTexCoord(0, 1, 0, 1)
	frametextTexture:ClearAllPoints()
	frametextTexture:SetAllPoints(frametext)

	frametextTexture:SetColorTexture(1,1,1,0)

	-- paramétres background
	for i = 1,10 do
		
		combos[i].frame:SetWidth(DOF_config.combo.width)
		combos[i].frame:SetHeight(DOF_config.combo.height)
		combos[i].frame:ClearAllPoints()
		combos[i].frame:SetPoint("CENTER", frame, "CENTER", (i-1)*DOF_config.combo.offsetx, -((i-1)*DOF_config.combo.offsety))
		--combos[i].frame:SetFrameLevel(level+i)	
		
		combos[i].overlay:SetWidth(DOF_config.combo.width)
		combos[i].overlay:SetHeight(DOF_config.combo.height)
		combos[i].overlay:SetPoint("CENTER", combos[i].frame, "CENTER", 0, 0)
		--combos[i].overlay:SetFrameLevel(level+i)				

		combos[i].texture:SetTexCoord(0, 1, 0, 1)
		combos[i].texture:SetWidth(32)
		combos[i].texture:SetHeight(32)
		combos[i].texture:SetAllPoints(combos[i].overlay)
		combos[i].texture:SetTexture(DOF_config.combo.texturePath)
		combos[i].texture:SetBlendMode(DOF_config.combo.mode)
		
		combos[i].overlay.texture = combos[i].texture
	
	end		
	
	if DOF_config.combo.ptype==1 then
		for i = 1,10 do
			combos[i].frame:ClearAllPoints()
			combos[i].frame:SetPoint("CENTER", frame, "CENTER", (i-1)*DOF_config.combo.offsetx, -((i-1)*DOF_config.combo.offsety))
		end
	else
		local angleA=DOF_config.combo.angleA
		local angleB=DOF_config.combo.angleB
		local pas = (angleB-angleA)/5
		
		for i = 1,10 do
			
			local px=DOF_config.combo.rayon*math.cos(angleA/180*math.pi)
			local py=DOF_config.combo.rayon*math.sin(angleA/180*math.pi)
			
			combos[i].frame:ClearAllPoints()
			combos[i].frame:SetPoint("CENTER", frame, "CENTER", px, -py)
	
			angleA=angleA+pas
			
		end		
	end

	DF:MySetFont(combotext,DOF_config.combo.fontPath,DOF_config.combo.fontSize,"OUTLINE")
	combotext:SetWidth(64)
	combotext:SetHeight(64)	
	combotext:SetJustifyH('CENTER')
	combotext:SetJustifyV('MIDDLE')	
	combotext:SetShadowColor(0, 0, 0, 0.75)
	combotext:SetShadowOffset(0.5, -0.5)
	combotext:SetTextColor(DOF_config.combo.textColor.r, DOF_config.combo.textColor.v, DOF_config.combo.textColor.b, DOF_config.combo.textColor.a)
	combotext:ClearAllPoints()
	combotext:SetPoint("CENTER", frametextzoom,"CENTER", 0,0)
	combotext:SetText("")

	if not DOF_config.combo.enable then 
		for i = 1,10 do combos[i].overlay:Hide() end
	end

	if not DOF_config.combo.showText then 
		frametext:Hide()
	else
		frametext:Show()
	end
	
end

function DF:combo_getTexture(num)
	return combos[num].texture
end

function DF:combo_toggle()

	if DF.playerClass=="DRUID" or DF.playerClass=="ROGUE" then

		combos[6].state=-1
		
	end
	
end

-- gestion de l'animation
function DF:combo_update(elapsed)

	if not DOF_config.combo.enable or not DF:toggle_isEnable() then
		for i = 1,10 do combos[i].overlay:Hide() end
		return
	end

	tempo=tempo+elapsed
	if tempo<frequency then return end
	tempo=0
	
	if (DF.configmode) then
		frameTexture:SetColorTexture(1,1,1,0.25)
		frametextTexture:SetColorTexture(1,1,1,0.25)
	else
		frameTexture:SetColorTexture(1,1,1,0)
		frametextTexture:SetColorTexture(1,1,1,0)
	end

	local currentForm = DF:currentForm()
	local c = 0
	local c2=0
	local multiple=1
	DF.currentCombos=0

	DF:combo_toggle()

	if not DF:form_goofForm(DOF_config.combo.form,currentForm) then
		for i = 1,10 do combos[i].overlay:Hide() end
		return
	end
	
	if ((DF.playerClass=="DRUID" and DF:currentForm()~=1) or DF.playerClass=="ROGUE" or DF.configmode) then
		
		local max_cp = UnitPowerMax("player", SPELL_POWER_COMBO_POINTS)
		if max_cp == 0 then
			max_cp = 5
		end
		
		DF:combo_maxactive(max_cp)

		c=UnitPower("player", SPELL_POWER_COMBO_POINTS)
		if not c or c==nil then
			c=0
		end
				
		if DOF_config.combo.showText and ((c and c>0) or DF.configmode) then
			
			if not DF.configmode then
				combotext:SetText(tostring(c))
			else
				combotext:SetText("5")
			end
			
		else
		
			combotext:SetText("")
			
		end

		DF.currentCombos=c
	
		for i = 1,max_cp do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]
				
				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1

			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				combos[i].state=0
				
			end
			
		end

	elseif (DF.playerClass=="MONK") then	

		local max_chi = UnitPowerMax("player", SPELL_POWER_CHI)
		if max_chi == 0 then
			max_chi = 5
		end
			
		DF:combo_maxactive(max_chi)
		
		c = UnitPower("player", SPELL_POWER_CHI)
		
		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c
		
		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end

		for i = 1,max_chi do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]
				
				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1

			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				combos[i].state=0
				
			end
			
		end
		
	elseif (DF.playerClass=="DRUID" and DF:currentForm()==1) then
		
		DF:combo_maxactive(3)

		c = comboPts
		
		if not c or c==nil then
			c=0
		end
			
		DF.currentCombos=c
				
		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("3")
		end
						
		for i = 1,3 do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[4]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[3]
				
				combos[i].state=0
				
			end
			
		end
		
	elseif DF.playerClass=="DEATHKNIGHT" then
		
		local max_runes = UnitPowerMax("player", SPELL_POWER_RUNES)
		
		DF:combo_maxactive(max_runes)
		combotext:SetText("")
		DF.currentCombos=0

		for i = 1,max_runes do

			--local runeType = GetRuneType(i)-1
			local start, duration, runeReady = GetRuneCooldown(i)

			if runeReady then
				
				if i==1 or i==2 then
					combos[i].sTexture=DOF_config.combo.textures[6]
				elseif i==3 or i==4 then
					combos[i].sTexture=DOF_config.combo.textures[10]
				elseif i==5 or i==6 then
					combos[i].sTexture=DOF_config.combo.textures[8]
				end
				
				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion
					combos[i].state=3
				end	
			else

				if i==1 or i==2 then
					combos[i].sTexture=DOF_config.combo.textures[5]
				elseif i==3 or i==4 then
					combos[i].sTexture=DOF_config.combo.textures[9]
				elseif i==5 or i==6 then
					combos[i].sTexture=DOF_config.combo.textures[7]
				end

				combos[i].state=0	
				
			end
			
		end

	elseif DF.playerClass == "SHAMAN" then

		DF:combo_maxactive(5)

		local Maelstrom = GetSpellInfo(53817)
		local _,_,_, MaelstromCount, _,_,_, _ = UnitAura("player", Maelstrom, nil, "HELPFUL")
		c = MaelstromCount

		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c

		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end
						
		for i = 1,5 do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				
				combos[i].state=0
				
			end
			
		end

	elseif DF.playerClass == "WARRIOR" then

		DF:combo_maxactive(5)

		local Tasteforblood = GetSpellInfo(125831)
		local _,_,_, TasteforbloodCount, _,_,_, _ = UnitAura("player", Tasteforblood, nil, "HELPFUL")
		c = TasteforbloodCount

		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c

		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end
						
		for i = 1,5 do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				
				combos[i].state=0
				
			end
			
		end

	elseif DF.playerClass == "HUNTER" then

		local max_mongoosefury = 6
	
		DF:combo_maxactive(max_mongoosefury)

		local MongooseFury = GetSpellInfo(190931)
		local _,_,_, MongooseFuryCount, _,_,_, _ = UnitAura("player", MongooseFury, nil, "HELPFUL")
		c = MongooseFuryCount

		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c

		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("6")
		end
						
		for i = 1,max_mongoosefury do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				
				combos[i].state=0
				
			end
			
		end



	elseif DF.playerClass=="PALADIN" then
		
		local max_holy = UnitPowerMax("player", SPELL_POWER_HOLY_POWER)
		if max_holy == 0 then
			max_holy = 5
		end
		
		DF:combo_maxactive(max_holy)

		c = UnitPower("player",SPELL_POWER_HOLY_POWER)

		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c

		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end
						
		for i = 1,max_holy do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[14]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[13]
				
				combos[i].state=0
				
			end
			
		end

	elseif DF.playerClass=="WARLOCK" then

		local max_shards = UnitPowerMax( "player", SPELL_POWER_SOUL_SHARDS )
		if max_shards == 0 then
			max_shards = 5
		end
		
		DF:combo_maxactive(max_shards)

		c = UnitPower("player",SPELL_POWER_SOUL_SHARDS)

		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c

		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end
						
		for i = 1,max_shards do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				
				combos[i].state=0
				
			end
			
		end

	elseif DF.playerClass=="PRIEST" then

		DF:combo_maxactive(5)

		c = UnitPower("player",SPELL_POWER_SHADOW_ORBS)

		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c

		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end
						
		for i = 1,5 do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				
				combos[i].state=0
				
			end
			
		end

	elseif DF.playerClass=="MAGE" then

		local  max_arcane = UnitPowerMax("player", SPELL_POWER_ARCANE_CHARGES)
		if max_arcane == 0 then
			max_arcane = 5
		end

		DF:combo_maxactive(max_arcane)

    local arcaneBlast = GetSpellInfo(36032)
    local _,_,_, arcaneBlastCount, _,_,_, _ = UnitAura("player", arcaneBlast, nil, "HELPFUL")
		c = arcaneBlastCount

		if not c or c==nil then
			c=0
		end
		
		DF.currentCombos=c

		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end
						
		for i = 1,max_arcane do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				
				combos[i].state=0
				
			end
			
		end
		
		
	else
		
		DF:combo_maxactive(5)

		c = comboPts
		
		if not c or c==nil then
			c=0
		end
			
		DF.currentCombos=c
				
		if DOF_config.combo.showText and c and c>0 then
			combotext:SetText(tostring(c))
		else
			combotext:SetText("")
		end
		if DOF_config.combo.showText and DF.configmode then
			combotext:SetText("5")
		end
						
		for i = 1,5 do
		
			if i<=c or DF.configmode then
				
				-- point ON
				combos[i].sTexture=DOF_config.combo.textures[2]

				if combos[i].state==0 then
					combos[i].scale = DOF_config.combo.impulsion + (multiple*0.1)
					multiple = multiple + 1
				end	
				
				combos[i].state=1
				
			else
				
				-- point OFF
				combos[i].sTexture=DOF_config.combo.textures[1]
				
				combos[i].state=0
				
			end
			
		end
		
	end

	for i = 1,10 do
		
		combos[i].scale = combos[i].scale - 0.05
		
		if combos[i].scale<1 then
				combos[i].scale=1
		end	
	
		combos[i].texture:SetTexture(combos[i].sTexture)	
		combos[i].overlay:SetScale(combos[i].scale)
		
	end
	
end

function DF:combo_set(nb)
	
	comboPts = nb
	
end

-- display X number of combo points
function DF:combo_maxactive(maxi)
	
	for i = 1, 10 do
		
		if i<=maxi then
			combos[i].overlay:Show()
		else
			combos[i].overlay:Hide()
		end
		
	end
	
end

function DF:combo_setAlpha(value)
	
	for i = 1, 10 do
		
		combos[i].overlay:SetAlpha(value)
		
	end
	
end

-- enable/disable déplacement du cadre avec la souris
function DF:combo_toogle_lock(flag)
	
	frame:EnableMouse(flag)
	frametext:EnableMouse(flag)
	
end

function DF:combo_reinit()
	
	DF:init_combo_frame()
	DF:combo_toogle_lock(DF.configmode)
	DF:options_setLevel()
	
end

function DF:combo_setLevel()
	local level = DOF_config.combo.newLevel
	DF:setMyFrameLevel(frame,level,"combo")
	DF:setMyFrameLevel(frametextzoom,level+8)
	DF:setMyFrameLevel(frametext,level+7)
	
	for i = 1,10 do
		DF:setMyFrameLevel(combos[i].overlay,level+i)
	end
end