----------------------------------------------------------------------------------------------------
-- DotFocus
-- Author: Snowcloud (Micâh - Antonidas)
-- Codebase by: Meranannon (Insane - Vol'jin)
----------------------------------------------------------------------------------------------------

local DF = DOF_namespace
local _
local is_prowling = 0;

DF.dotPowerDatas={}

-- RAKE
local rakeName, _, _, _, _, _ = GetSpellInfo(155722)
DF.dotPowerDatas[rakeName]={
	base=99,				--	base damage
	baseap=0.30665,	--	damage give by power attack
	basecp=0,				--	base damage per combo point (if spell use combo point, else zero)
}

-- RIP
local ripName, _, _, _, _, _ = GetSpellInfo(1079)
DF.dotPowerDatas[ripName]={
	base=112.76,
	baseap=0.0484,
	basecp=320,
}

-- THRASH
local trashName, _, _, _, _, _ = GetSpellInfo(106830)
DF.dotPowerDatas[trashName]={
	base=686,
	baseap=0.0936,
	basecp=0,
}

-- ASHAMANES FRENZY
local ashamanesFrenzyName, _, _, _, _, _ = GetSpellInfo(210722)
DF.dotPowerDatas[ashamanesFrenzyName]={
  base=686,       -- TODO ??
  baseap=0.0936,  -- TODO ??
  basecp=0,
}

function DF:GetBleedAbilityDamageCoefficient(docActive, spellid)
    
    -- nouvelle formule, ne tiens compte que du rugissement, fureur du tigre et bloodtalons
    local damageCoeff=1

    if DF:spell_exist(nil,DF.SavageRoarName,"player","HELPFUL|PLAYER",false) then  -- savage roar
    	damageCoeff=damageCoeff*1.25
    end
    if DF:spell_exist(nil,DF.TigerFuryName,"player","HELPFUL|PLAYER",false) then   -- tiger furor
    	damageCoeff=damageCoeff*1.15
    end
    if (spellid==DF.RakeName) and is_prowling then                                 -- rake when prowling
        damageCoeff=damageCoeff*2.00
    end
	  if docActive then	                                                             -- bloodtalons damage boost	
		  damageCoeff=damageCoeff*1.40
    end

    -- this is like a memory of prowling, because the prowling aura is removed immediately when rake is done.
    -- meaning, it is not possible to check for the aura anymore once rake was executed. we have to remember it from before
    -- is ugly, but probably no better solution
    is_prowling = DF:spell_exist(nil,DF.ProwlName,"player","HELPFUL|PLAYER",false)

    return damageCoeff
    
end

function DF:GetDotPower(spellid,docActive,forceCP)
   
    local bleedCoeff
    local CP = UnitPower('player', 4)
    local dotPower=0
    local bleedBase
    
    if DF.dotPowerDatas[spellid] then
	
			bleedCoeff = DF:GetBleedAbilityDamageCoefficient(docActive, spellid)
			
	    if forceCP then CP=forceCP end
	    if DF.dotPowerDatas[spellid].basecp==0 then CP=1 end
	    
	    bleedBase = (DF.dotPowerDatas[spellid].base
	                   +(DF.dotPowerDatas[spellid].basecp * CP))
	                   +((DF.dotPowerDatas[spellid].baseap * DF.playerAP) * CP)
	    
	    dotPower = bleedCoeff * bleedBase

	  end
	  
    return dotPower
    
end

function DF:GetAbiPower(spellid)
	local targetID=UnitGUID("playertarget")
	if targetID and DF.abiPowers[targetID] and DF.abiPowers[targetID][spellid] then
		return DF.abiPowers[targetID][spellid]
	else
		return nil
	end
end

